Index: code/branches/campaignHS15/data/levels/Campaign1.oxw
===================================================================
--- code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10710)
+++ code/branches/campaignHS15/data/levels/Campaign1.oxw	(revision 10711)
@@ -53,5 +53,5 @@
     >
 
-    <SpawnPoint name="playerSpawn" team=1 position="6000,-4000,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff2 />
+    <SpawnPoint name="playerSpawn" team=0 position="6000,-4000,0" lookat="0,0,0" spawnclass=SpaceShip pawndesign=spaceshipassff2 />
 
     <WorldAmbientSound source="Earth.ogg" looping="true" playOnLoad="true" />
@@ -321,5 +321,5 @@
     </SimpleNotification>
 
-    <!--STRUCTURE -->
+    <!--STATIONS -->
 
     <!-- (Temporary) Template for stations. Used to define common features of all Stations. -->
@@ -351,22 +351,86 @@
     </Template>
 
-    <Dock position="5000,-3000,0" active=true >
-        <animations>
-            <MoveToDockingTarget target="dockA" />
-        </animations>
-        <effects>
-            <DockToShip target="newSpaceShip" />
-        </effects>
-        <events>
-            <execute>
-                <EventListener event="dockMe" />
-            </execute>
-        </events>
+    <!-- A, Coordinates are approx. (cos(29pi/16), sin(29pi/16), 0)*3000 -->
+    <Pawn name="statA" team=0 radarname="Station A" position="5000,-3000,0" direction="0,1,0" initialhealth=10000 maxhealth=10000>
+        <templates>
+            <Template link="station" />
+        </templates>
         <attached>
-            <DistanceTrigger position="0,0,0" distance="200" target="SpaceShip" beaconMode="exclude" targetname="NPC" name="dockMe" />
-            <Billboard position="0,0,0" amplitude=1 material="Flares/lensflare" colour="1,0,0.05" />
+            <DockingTarget name="dockTargetA" />
+            <Dock position="0,0,0" active=true>
+                <animations>
+                    <MoveToDockingTarget target="dockTargetA" />
+                </animations>
+                <effects>
+                    <DockToShip target="newSpaceShip" />
+                </effects>
+                <events>
+                    <execute>
+                        <EventListener event="dockA" />
+                    </execute>
+                </events>
+                <attached>
+                    <DistanceTrigger position="0,0,0" distance="200" target="SpaceShip" beaconMode="exclude" targetname="NPC" name="dockA" />
+                    <Billboard position="0,0,0" amplitude=1 material="Flares/lensflare" colour="1,0,0.05" />
+                </attached>
+            </Dock>
         </attached>
-    </Dock>
-
+    </Pawn>
+
+    <!-- B, Coordinates are approx. (-cos(29pi/16), sin(29pi/16), 0)*3000 -->
+    <Pawn name="statB" team=0 radarname="Station B" position="-5000,-3000,0" direction="0,1,0" initialhealth=10000 maxhealth=10000>
+        <templates>
+            <Template link="station" />
+        </templates>
+        <attached>
+            <DockingTarget name="dockTargetB" />
+            <Dock position="0,0,0" active=true>
+                <animations>
+                    <MoveToDockingTarget target="dockTargetB" />
+                </animations>
+                <effects>
+                    <DockToShip target="newSpaceShip" />
+                </effects>
+                <events>
+                    <execute>
+                        <EventListener event="dockB" />
+                    </execute>
+                </events>
+                <attached>
+                    <DistanceTrigger position="0,0,0" distance="200" target="SpaceShip" beaconMode="exclude" targetname="NPC" name="dockB" />
+                    <Billboard position="0,0,0" amplitude=1 material="Flares/lensflare" colour="1,0,0.05" />
+                </attached>
+            </Dock>
+        </attached>
+    </Pawn>
+
+    <!-- C -->
+    <Pawn name="statC" team=0 radarname="Station C" position="0,-2300,0" direction="0,1,0" initialhealth=10000 maxhealth=10000>
+        <templates>
+            <Template link="station" />
+        </templates>
+        <attached>
+            <DockingTarget name="dockTargetC" />
+            <Dock position="0,0,0" active=true>
+                <animations>
+                    <MoveToDockingTarget target="dockTargetC" />
+                </animations>
+                <effects>
+                    <DockToShip target="fpsMode" />
+                </effects>
+                <events>
+                    <execute>
+                        <EventListener event="dockC" />
+                    </execute>
+                </events>
+                <attached>
+                    <DistanceTrigger position="0,0,0" distance="200" target="SpaceShip" beaconMode="exclude" targetname="NPC" name="dockC" />
+                    <Billboard position="0,0,0" amplitude=1 material="Flares/lensflare" colour="1,0,0.05" />
+                </attached>
+            </Dock>
+        </attached>
+    </Pawn>
+
+    <!-- New SpaceShip as destination of dock C-->
     <SpaceShip
         template            = "spaceshipassff2"
@@ -390,36 +454,12 @@
     </SpaceShip>
 
-    <!-- FPS Player as destination of the dock -->
-    <FpsPlayer template = "fps" radarname = "First Person Player" position = "0,-19900,0" >
+    <!-- FPS Player as destination of dock C-->
+    <FpsPlayer template = "fps" radarname = "First Person Player" position = "0,-2300,640" lookat="0,0,0" >
         <attached>
-            <DockingTarget name="newSpaceShip" />
-            <DistanceTriggerBeacon name="NPC" />
+            <DockingTarget name="fpsMode" />
+            <DistanceTriggerBeacon name="fpsPlayer" />
         </attached>
     </FpsPlayer>
 
-    <!-- A, Coordinates are approx. (cos(29pi/16), sin(29pi/16), 0)*3000 -->
-    <Pawn name="statA" radarname="Station A" position="5000,-3000,0" direction="0,1,0" initialhealth=10000 maxhealth=10000>
-        <templates>
-            <Template link="station" />
-        </templates>
-        <attached>
-            <DockingTarget name="dockA" />
-        </attached>
-    </Pawn>
-
-    <!-- B, Coordinates are approx. (-cos(29pi/16), sin(29pi/16), 0)*3000 -->
-    <Pawn name="statB" radarname="Station B" position="-5000,-3000,0" direction="0,1,0" initialhealth=10000 maxhealth=10000>
-        <templates>
-            <Template link="station" />
-        </templates>
-    </Pawn>
-
-    <!-- C -->
-    <Pawn name="statC" radarname="Station C" position="0,-2500,0" direction="0,1,0" initialhealth=10000 maxhealth=10000>
-        <templates>
-            <Template link="station" />
-        </templates>
-    </Pawn>
-
     <!--ELEMENTS -->
 
@@ -428,11 +468,11 @@
         asteroidBelt(0,-2000, 0, 30, 0, 5, 20, 40, 500, 3300, 75, 0)
     ?>
-    <!--
-    <?lua
-        dofile("includes/fog.lua")
-       generateFog(-1000,-1000,0,20,0.9)
-    ?>
-    -->
-
+
+    <?lua
+    --[[
+    dofile("includes/fog.lua")
+    generateFog(-1000,-1000,0,20,0.9)
+    ]]--
+    ?>
 
     <!-- Enemies. Outer loop defines waves, inner loop defines enemies in every wave. -->
@@ -447,5 +487,5 @@
     y = math.sin(math.pi/8*(i+1))*1500
     ?>
-    <SpaceShip visible=false active=flase name="attackers<?lua print(k)?>" radarname="Attacker" position="<?lua print(x)?>,<?lua print(y)?>,<?lua print(math.pow(-1,i)*250) ?>" lookat="0,0,0" team=2>
+    <SpaceShip visible=false active=flase name="attackers<?lua print(k)?>" radarname="Attacker" position="<?lua print(x)?>,<?lua print(y)?>,<?lua print(math.pow(-1,i)*250) ?>" lookat="0,0,0" team=1>
         <templates>
             <Template link="spaceshippirate" />
@@ -478,6 +518,6 @@
     <?lua end ?>
 
-    <!-- Transporter, starting Point is near A, end Point near B, the circle parameters for the waypoints are: Center = (0, -887, 0), r = 2613 --
-    <SpaceShip position="5000,-3000,0" lookat="-2494, -1667, 0" team=1 name="transporter" radarname="Shuttle">
+    <!-- Transporter, starting Point is near A, end Point near B, the circle parameters for the waypoints are: Center = (0, -887, 0), r = 2613 -->
+    <SpaceShip position="5000,-3000,0" lookat="-2494, -1667, 0" team=0 name="transporter" radarname="Shuttle">
         <templates>
             <Template link="spaceshipTransporter" />
@@ -487,7 +527,7 @@
         </attached>
         <controller>
-            <WaypointController accuracy=10>
+            <WaypointController accuracy=10 team=0>
                 <waypoints>
-                    !-- A to B --
+                    <!-- A to B -->
                     <?lua
                     max = 5
@@ -500,8 +540,8 @@
                     <?lua end ?>
 
-                    !-- Return Point --
+                    <!-- Return Point -->
                     <Billboard position="-5000, -3000, 0" amplitude=1 material="Flares/lensflare" colour="1,1,0.05"/>
 
-                    !-- B to A --
+                    <!-- B to A -->
                     <?lua
                     max = 5
@@ -514,10 +554,10 @@
                     <?lua end ?>
 
-                    !-- Start Point --
+                    <!-- Start Point -->
                     <Billboard position="5000,-3000,0" amplitude=1 material="Flares/lensflare" colour="1,1,0.05"/>
                 </waypoints>
             </WaypointController>
         </controller>
-    </SpaceShip/> -->
+    </SpaceShip>
 
     </Scene>
Index: code/branches/campaignHS15/data/levels/missionOne.oxw
===================================================================
--- code/branches/campaignHS15/data/levels/missionOne.oxw	(revision 10710)
+++ code/branches/campaignHS15/data/levels/missionOne.oxw	(revision 10711)
@@ -1659,10 +1659,10 @@
 
 <!-- @Triggers: HACK. The attacktrigger6 Event is created, but does not trigger the Script.
-(WTF?) TODO: looks like a BUG 
+(WTF?) TODO: looks like a BUG
 Thus a distanceTrigger is created, that gets enabled, when the inner trigger gets activated.
 Due to the large radius it is likely that it actually gets triggered.
 -->
 
-  <DistanceTrigger name="testDistanceTrigger" position="0,0,0" distance=10000 target="SpaceShip" stayActive="true" delay=37.0>
+  <DistanceTrigger name="testDistanceTrigger" position="0,0,0" distance=10000 target="Pawn" stayActive="true" delay=37.0>
     <EventTrigger name="testEventTrigger" activations="1" stayactive="true" delay=0.1>
       <events>