Index: branches/presentation/src/util/hud.cc
===================================================================
--- branches/presentation/src/util/hud.cc	(revision 10699)
+++ branches/presentation/src/util/hud.cc	(revision 10716)
@@ -58,28 +58,6 @@
   this->resY = 1;
 
-  this->overlayPercentage = 40;
-  this->overlayActive = false;
-  this->rightRect = new OrxGui::GLGuiImage();
-  this->leftRect = new OrxGui::GLGuiImage();
-  this->topRect = new OrxGui::GLGuiImage();
-  this->bottomRect = new OrxGui::GLGuiImage();
-  this->middleRect = new OrxGui::GLGuiImage();
-
-  this->inputLine = new OrxGui::GLGuiInputLine();
-  //this->inputLine->setParent2D(this);
-  this->notifier = new OrxGui::GLGuiNotifier();
-  this->notifier->setParent2D(this->bottomRect);
-  notifier->setRelCoor2D(5,5);
+	this->init();
   
-  this->barSocket = new OrxGui::GLGuiImage();
-  this->barSocket->setParent2D(this->bottomRect);
-
-  this->_radar = new OrxGui::GLGuiRadar();
-  this->radarCenterNode = NULL;
-
-  this->subscribeEvent(ES_ALL, EV_VIDEO_RESIZE);
-  this->subscribeEvent(ES_ALL, SDLK_TAB);
-
-  //this->shipValuesBox = NULL;
 }
 
@@ -100,4 +78,5 @@
   delete this->bottomRect;
   delete this->middleRect;
+  
 
   //if (this->shipValuesBox != NULL)
@@ -105,4 +84,57 @@
 
   // delete what has to be deleted here
+}
+
+void Hud::init()
+{
+	this->overlayPercentage = 40;
+	this->overlayActive = false;
+	this->rightRect = new OrxGui::GLGuiImage();
+	this->leftRect = new OrxGui::GLGuiImage();
+	this->topRect = new OrxGui::GLGuiImage();
+	this->bottomRect = new OrxGui::GLGuiImage();
+	this->middleRect = new OrxGui::GLGuiImage();
+
+	this->inputLine = new OrxGui::GLGuiInputLine();
+	this->inputLine->setParent2D(this);
+	this->notifier = new OrxGui::GLGuiNotifier();
+	this->notifier->setParent2D(this);
+	notifier->setAbsCoor2D(100,100);
+	
+	this->barSocket = new OrxGui::GLGuiImage();
+	this->barSocket->setParent2D(this->bottomRect);
+	
+	this->_radar = new OrxGui::GLGuiRadar();
+	this->radarCenterNode = NULL;
+	
+	this->subscribeEvent(ES_ALL, EV_VIDEO_RESIZE);
+	this->subscribeEvent(ES_ALL, SDLK_TAB);
+  
+	if (this->playmode == FirstPerson)
+	{
+		this->topHit = new OrxGui::GLGuiImage();
+		this->topHit->loadImageFromFile("textures/gui/gui_hitbar.png");
+		this->topHit->setParent2D(this->middleRect);
+		this->topHit->setRelDir2D(-1.5708);
+		
+		this->bottomHit = new OrxGui::GLGuiImage();
+		this->bottomHit->loadImageFromFile("textures/gui/gui_hitbar.png");
+		this->bottomHit->setParent2D(this->middleRect);
+		this->bottomHit->setRelDir2D(1.5708);
+		
+		this->leftHit = new OrxGui::GLGuiImage();
+		this->leftHit->loadImageFromFile("textures/gui/gui_hitbar.png");
+		this->leftHit->setParent2D(this->middleRect);
+		
+		this->rightHit = new OrxGui::GLGuiImage();
+		this->rightHit->loadImageFromFile("textures/gui/gui_hitbar.png");
+		this->rightHit->setParent2D(this->middleRect);
+		this->rightHit->setRelDir2D(3.1416);
+		
+		this->leftRect->setParent2D(this);
+		this->rightRect->setParent2D(this);
+	}
+
+  //this->shipValuesBox = NULL;
 }
 
@@ -321,4 +353,10 @@
 */
 
+void Hud::setMode(Hud::Playmode playmode)
+{
+	this->playmode = playmode;
+	this->init();
+}
+
 void Hud::updateWeaponManager()
 {
@@ -390,5 +428,5 @@
   this->resY = State::getResY();
 
-  this->setSize2D(.2 * this->resX, this->resY);
+  this->setSize2D(this->resX, this->resY);
   if( this->playmode != FirstPerson )
   {
@@ -410,19 +448,18 @@
   if( this->playmode != FirstPerson )
   {
-	  this->leftRect->setParent2D(this);
+	  
 	  this->leftRect->setWidgetSize(float(overlayWidth), float(this->resY));
 	  this->leftRect->setAbsCoor2D(0,0);
-	  this->leftRect->setBackgroundTexture(Texture());
+	  /*this->leftRect->setBackgroundTexture(Texture());
 	  this->leftRect->setBackgroundColor(Color(0,0,0.7,0.2));
 	  this->leftRect->setForegroundTexture(Texture());
-	  this->leftRect->setForegroundColor(Color(0,0,0,0));
-	
-	  this->rightRect->setParent2D(this);
+	  this->leftRect->setForegroundColor(Color(0,0,0,0));*/
+	  
 	  this->rightRect->setWidgetSize(float(overlayWidth), float(this->resY));
 	  this->rightRect->setAbsCoor2D(this->resX - overlayWidth,0);
-	  this->rightRect->setBackgroundTexture(Texture());
+	  /*this->rightRect->setBackgroundTexture(Texture());
 	  this->rightRect->setBackgroundColor(Color(0,0,0.7,0.2));
 	  this->rightRect->setForegroundTexture(Texture());
-	  this->rightRect->setForegroundColor(Color(0,0,0,0));
+	  this->rightRect->setForegroundColor(Color(0,0,0,0));*/
   }
   else
@@ -431,10 +468,17 @@
 	  this->bottomRect->setWidgetSize(float(this->resX), float(overlayWidth));
 	  this->bottomRect->setAbsCoor2D(0, this->resY - overlayWidth);
+	  
 	  this->topRect->setParent2D(this);
 	  this->topRect->setWidgetSize(float(this->resX), float(overlayWidth));
 	  this->topRect->setAbsCoor2D(0, 0);
+	  
 	  this->middleRect->setParent2D(this);
-	  this->middleRect->setWidgetSize(float(this->resY)/2, float(this->resY)/2);
-	  this->middleRect->setAbsCoor2D(float(this->resX - this->resY/2)/2, float(this->resY)/4);
+	  //this->middleRect->setWidgetSize(float(this->resY)/2, float(this->resY)/2);
+	  this->middleRect->setAbsCoor2D(/*float(this->resX - this->resY/2)/2, float(this->resY)/4*/float(this->resX/2), float(this->resY/2));
+	  
+	  this->bottomHit->setRelCoor2D(0, this->resY/4);
+	  this->topHit->setRelCoor2D(0, -this->resY/4);
+	  this->leftHit->setRelCoor2D(-this->resX/4, 0);
+	  this->rightHit->setRelCoor2D(this->resX/4, 0);
   }
 
Index: branches/presentation/src/util/hud.h
===================================================================
--- branches/presentation/src/util/hud.h	(revision 10699)
+++ branches/presentation/src/util/hud.h	(revision 10716)
@@ -47,5 +47,5 @@
   void notifyUser(const std::string& message);
 
-  inline void setMode(Hud::Playmode playmode) {this->playmode = playmode;};
+  void setMode(Hud::Playmode playmode);
   inline Hud::Playmode getMode() {return this->playmode;};
 
@@ -93,4 +93,5 @@
   private:
     void updateResolution();
+    void init();
     //void createShipValuesBox();
 
@@ -119,4 +120,8 @@
   OrxGui::GLGuiWidget*		middleRect;
   OrxGui::GLGuiWidget*		barSocket;
+  OrxGui::GLGuiImage*		topHit;
+  OrxGui::GLGuiImage*		bottomHit;
+  OrxGui::GLGuiImage*		leftHit;
+  OrxGui::GLGuiImage*		rightHit;
   bool                     overlayActive;
   int                      overlayPercentage; //the percentage of the screen, the player has got for his movements. should always be a value between 0 and 1;