Index: /code/trunk/src/libraries/tools/Shader.cc
===================================================================
--- /code/trunk/src/libraries/tools/Shader.cc	(revision 10726)
+++ /code/trunk/src/libraries/tools/Shader.cc	(revision 10727)
@@ -161,5 +161,5 @@
         @brief Defines a new integer value for a given parameter. The parameter will be updated if the compositor is rendered the next time.
     */
-    void Shader::setParameter(size_t technique, size_t pass, const std::string& parameter, int value)
+    void Shader::setParameter(unsigned short technique, unsigned short pass, const std::string& parameter, int value)
     {
         ParameterContainer container = {technique, pass, parameter, value};
@@ -171,5 +171,5 @@
         @brief Defines a new float value for a given parameter. The parameter will be updated if the compositor is rendered the next time.
     */
-    void Shader::setParameter(size_t technique, size_t pass, const std::string& parameter, float value)
+    void Shader::setParameter(unsigned short technique, unsigned short pass, const std::string& parameter, float value)
     {
         ParameterContainer container = {technique, pass, parameter, value};
Index: /code/trunk/src/libraries/tools/Shader.h
===================================================================
--- /code/trunk/src/libraries/tools/Shader.h	(revision 10726)
+++ /code/trunk/src/libraries/tools/Shader.h	(revision 10727)
@@ -89,6 +89,6 @@
             virtual void cameraChanged(Ogre::Viewport* viewport, Ogre::Camera* oldCamera);
 
-            void setParameter(size_t technique, size_t pass, const std::string& parameter, float value);
-            void setParameter(size_t technique, size_t pass, const std::string& parameter, int value);
+            void setParameter(unsigned short technique, unsigned short pass, const std::string& parameter, float value);
+            void setParameter(unsigned short technique, unsigned short pass, const std::string& parameter, int value);
 
             virtual void notifyMaterialRender(Ogre::uint32 pass_id, Ogre::MaterialPtr& materialPtr);
@@ -110,6 +110,6 @@
             struct ParameterContainer
             {
-                size_t technique_;          ///< The ID of the technique
-                size_t pass_;               ///< The ID of the pass
+                unsigned short technique_;  ///< The ID of the technique
+                unsigned short pass_;       ///< The ID of the pass
                 std::string parameter_;     ///< The name of the parameter
 
Index: /code/trunk/src/modules/pong/PongAI.cc
===================================================================
--- /code/trunk/src/modules/pong/PongAI.cc	(revision 10726)
+++ /code/trunk/src/modules/pong/PongAI.cc	(revision 10727)
@@ -211,7 +211,7 @@
     {
         // Calculate the exponent for the position-formula
-        float exp = pow(10, 1 - 2*this->strength_); // strength: 0   -> exp = 10
-                                                    // strength: 0.5 -> exp = 1
-                                                    // strength: 1   -> exp = 0.1
+        float exp = pow(10.0f, 1.0f - 2.0f*this->strength_); // strength: 0   -> exp = 10
+                                                             // strength: 0.5 -> exp = 1
+                                                             // strength: 1   -> exp = 0.1
 
         // Calculate the relative position where to hit the ball with the bat
Index: /code/trunk/src/modules/towerdefense/TowerDefense.cc
===================================================================
--- /code/trunk/src/modules/towerdefense/TowerDefense.cc	(revision 10726)
+++ /code/trunk/src/modules/towerdefense/TowerDefense.cc	(revision 10727)
@@ -331,5 +331,5 @@
             timeSinceLastSpawn_ = 0.0;
 
-            timeUntilNextWave_ = waveNumber_+20;
+            timeUntilNextWave_ = waveNumber_+20.0f;
             waveSize_ = waveNumber_+5;
         }
Index: /code/trunk/src/modules/towerdefense/TowerDefenseTower.cc
===================================================================
--- /code/trunk/src/modules/towerdefense/TowerDefenseTower.cc	(revision 10726)
+++ /code/trunk/src/modules/towerdefense/TowerDefenseTower.cc	(revision 10727)
@@ -63,5 +63,5 @@
             float reloadrate = getReloadRate();
             float reloadwaittime = getReloadWaitTime();
-            this->setDamageMultiplier((upgrade+1)*2);
+            this->setDamageMultiplier((upgrade+1)*2.0f);
             //this->setRotationThrust(2*this->getRotationThrust());
             reloadrate = 0.5f*reloadrate;
Index: /code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.cc
===================================================================
--- /code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.cc	(revision 10726)
+++ /code/trunk/src/modules/weapons/projectiles/SplitGunProjectile.cc	(revision 10727)
@@ -134,5 +134,5 @@
             {
                 // Every child projectile should fly uniform in different directions -> Rotate the velocityOffset in every iteration
-                velocityOffset = Quaternion(Degree(360/numberOfChilds_), velocityInitial.normalisedCopy()) * velocityOffset;
+                velocityOffset = Quaternion(Degree(360.0f/numberOfChilds_), velocityInitial.normalisedCopy()) * velocityOffset;
                 velocityOffset.normalise();
 
Index: /code/trunk/src/orxonox/Scene.cc
===================================================================
--- /code/trunk/src/orxonox/Scene.cc	(revision 10726)
+++ /code/trunk/src/orxonox/Scene.cc	(revision 10727)
@@ -88,5 +88,5 @@
 
         // No physics yet, XMLPort will do that.
-        const int defaultMaxWorldSize = 100000;
+        const float defaultMaxWorldSize = 100000.0f;
         this->negativeWorldRange_ = Vector3::UNIT_SCALE * -defaultMaxWorldSize;
         this->positiveWorldRange_ = Vector3::UNIT_SCALE *  defaultMaxWorldSize;